#include <stdio.h>
#include "cuda.h"
#define max(x,y)  ((x) > (y)? (x) : (y))
#define min(x,y)  ((x) < (y)? (x) : (y))
#define ceil(a,b) ((a) % (b) == 0 ? (a) / (b) : ((a) / (b)) + 1)

void check_error (const char* message) {
	cudaError_t error = cudaGetLastError ();
	if (error != cudaSuccess) {
		printf ("CUDA error : %s, %s\n", message, cudaGetErrorString (error));
		exit(-1);
	}
}

__global__ void j2d81pt (double * __restrict__ l_in, double * __restrict__ l_out, int N) {
	//Determing the block's indices
	int i0 = (int)(blockIdx.x)*(int)(blockDim.x);
	int i = max(i0,0) + (int)(threadIdx.x);
	int j0 = 4*(int)(blockIdx.y)*(int)(blockDim.y);
	int j = max(j0,0) + 4*(int)(threadIdx.y);

	double (*in)[8200] = (double (*)[8200]) l_in;
	double (*out)[8200] = (double (*)[8200]) l_out;

	if (i>=0 & j>=0 & i<=N-9 & j<=N-9) {
double _t_1_;
double _t_14_;
double outjc0ic0;
double _t_3_;
double _t_2_;
double _t_0_;
double _t_4_;
double _t_9_;
double _t_7_;
double _t_17_;
double _t_5_;
double _t_15_;
double _t_28_;
double _t_12_;
double _t_11_;
double _t_10_;
double _t_8_;
double _t_18_;
double _t_6_;
double _t_16_;
double _t_13_;
double _t_20_;
double _t_30_;
double _t_43_;
double _t_33_;
double _t_45_;
double _t_32_;
double _t_22_;
double outjp1ic0;
double outjp2ic0;
double outjp3ic0;
double _t_24_;
double _t_35_;
double _t_48_;
double _t_50_;
double _t_37_;
double _t_52_;
double _t_39_;
double _t_27_;
double _t_40_;
double _t_55_;
double _t_21_;
double _t_31_;
double _t_44_;
double _t_46_;
double _t_23_;
double _t_34_;
double _t_47_;
double _t_19_;
double _t_29_;
double _t_49_;
double _t_42_;
double _t_36_;
double _t_25_;
double _t_41_;
double _t_53_;
double _t_38_;
double _t_26_;
double _t_54_;
double _t_51_;

_t_1_ = in[j][i+1];
_t_1_ += in[j][i+7];
_t_1_ += in[j+1][i];
_t_14_ = in[j+1][i];
_t_1_ += in[j+1][i+8];
_t_14_ += in[j+1][i+8];
_t_1_ += in[j+7][i];
_t_1_ += in[j+7][i+8];
_t_1_ += in[j+8][i+1];
_t_1_ += in[j+8][i+7];
outjc0ic0 = _t_1_ * 4.5339;
outjc0ic0 += in[j+4][i+4] * 8.10655;
_t_3_ = in[j][i+3];
_t_3_ += in[j][i+5];
_t_3_ += in[j+3][i];
_t_3_ += in[j+3][i+8];
_t_3_ += in[j+5][i];
_t_3_ += in[j+5][i+8];
_t_3_ += in[j+8][i+3];
_t_3_ += in[j+8][i+5];
outjc0ic0 += _t_3_ * 0.002856;
_t_2_ = in[j][i+2];
_t_2_ += in[j][i+6];
_t_2_ += in[j+6][i];
_t_2_ += in[j+6][i+8];
_t_2_ += in[j+8][i+2];
_t_2_ += in[j+8][i+6];
_t_2_ += in[j+2][i];
_t_2_ += in[j+2][i+8];
outjc0ic0 += _t_2_ * -0.000357;
_t_0_ = in[j][i];
_t_0_ += in[j][i+8];
_t_0_ += in[j+8][i];
_t_0_ += in[j+8][i+8];
outjc0ic0 += _t_0_ * 3.18622;
_t_4_ = in[j][i+4];
_t_4_ += in[j+4][i];
_t_4_ += in[j+4][i+8];
_t_4_ += in[j+8][i+4];
outjc0ic0 += _t_4_ * -0.00508225;
_t_9_ = in[j+2][i+2];
_t_9_ += in[j+2][i+6];
_t_9_ += in[j+6][i+2];
_t_9_ += in[j+6][i+6];
outjc0ic0 += _t_9_ * 0.04;
_t_7_ = in[j+3][i+1];
_t_7_ += in[j+1][i+3];
_t_17_ = in[j+1][i+3];
_t_17_ += in[j+4][i];
_t_17_ += in[j+4][i+8];
_t_17_ += in[j+6][i];
_t_17_ += in[j+6][i+8];
_t_7_ += in[j+1][i+5];
_t_17_ += in[j+1][i+5];
_t_7_ += in[j+3][i+7];
_t_7_ += in[j+7][i+3];
_t_7_ += in[j+7][i+5];
_t_7_ += in[j+5][i+1];
_t_7_ += in[j+5][i+7];
outjc0ic0 += _t_7_ * 0.04064;
_t_5_ = in[j+7][i+1];
_t_5_ += in[j+1][i+1];
_t_15_ = in[j+1][i+1];
_t_15_ += in[j+2][i];
_t_15_ += in[j+2][i+8];
_t_15_ += in[j+8][i];
_t_15_ += in[j+8][i+8];
_t_28_ = in[j+2][i];
_t_28_ += in[j+2][i+8];
_t_5_ += in[j+1][i+7];
_t_15_ += in[j+1][i+7];
_t_5_ += in[j+7][i+7];
outjc0ic0 += _t_5_ * 0.00064516;
_t_12_ = in[j+3][i+3];
_t_12_ += in[j+3][i+5];
_t_12_ += in[j+5][i+3];
_t_12_ += in[j+5][i+5];
outjc0ic0 += _t_12_ * 2.56;
_t_11_ = in[j+4][i+2];
_t_11_ += in[j+4][i+6];
_t_11_ += in[j+6][i+4];
_t_11_ += in[j+2][i+4];
outjc0ic0 += _t_11_ * 0.56944;
_t_10_ = in[j+2][i+3];
_t_10_ += in[j+2][i+5];
_t_10_ += in[j+3][i+2];
_t_10_ += in[j+3][i+6];
_t_10_ += in[j+5][i+2];
_t_10_ += in[j+5][i+6];
_t_10_ += in[j+6][i+3];
_t_10_ += in[j+6][i+5];
outjc0ic0 += _t_10_ * -0.32;
_t_8_ = in[j+4][i+1];
_t_8_ += in[j+1][i+4];
_t_18_ = in[j+1][i+4];
_t_18_ += in[j+5][i+8];
_t_18_ += in[j+5][i];
_t_8_ += in[j+4][i+7];
_t_8_ += in[j+7][i+4];
outjc0ic0 += _t_8_ * -0.0723189;
_t_6_ = in[j+6][i+1];
_t_6_ += in[j+1][i+2];
_t_16_ = in[j+1][i+2];
_t_16_ += in[j+3][i];
_t_16_ += in[j+3][i+8];
_t_16_ += in[j+7][i];
_t_16_ += in[j+7][i+8];
_t_6_ += in[j+1][i+6];
_t_16_ += in[j+1][i+6];
_t_6_ += in[j+6][i+7];
_t_6_ += in[j+7][i+2];
_t_6_ += in[j+7][i+6];
_t_6_ += in[j+2][i+1];
_t_6_ += in[j+2][i+7];
outjc0ic0 += _t_6_ * -0.00508;
_t_13_ = in[j+4][i+3];
_t_13_ += in[j+4][i+5];
_t_13_ += in[j+3][i+4];
_t_13_ += in[j+5][i+4];
outjc0ic0 += _t_13_ * -4.55552;
out[j][i] = outjc0ic0;
_t_20_ = in[j+2][i+2];
_t_20_ += in[j+2][i+6];
_t_20_ += in[j+3][i+1];
_t_20_ += in[j+3][i+7];
_t_20_ += in[j+7][i+1];
_t_20_ += in[j+7][i+7];
_t_20_ += in[j+8][i+2];
_t_20_ += in[j+8][i+6];
_t_30_ = in[j+2][i+2];
_t_30_ += in[j+2][i+6];
_t_30_ += in[j+4][i];
_t_30_ += in[j+4][i+8];
_t_30_ += in[j+8][i];
_t_30_ += in[j+8][i+8];
_t_43_ = in[j+3][i+1];
_t_43_ += in[j+3][i+7];
_t_43_ += in[j+4][i];
_t_43_ += in[j+4][i+8];
_t_33_ = in[j+3][i+1];
_t_33_ += in[j+3][i+7];
_t_45_ = in[j+3][i+3];
_t_45_ += in[j+3][i+5];
_t_45_ += in[j+6][i];
_t_45_ += in[j+6][i+8];
_t_45_ += in[j+8][i];
_t_45_ += in[j+8][i+8];
_t_32_ = in[j+2][i+4];
_t_32_ += in[j+6][i+8];
_t_32_ += in[j+6][i];
_t_22_ = in[j+2][i+4];
_t_22_ += in[j+5][i+1];
_t_22_ += in[j+5][i+7];
_t_22_ += in[j+8][i+4];
outjp1ic0 = in[j+5][i+4] * 8.10655;
outjp1ic0 += _t_20_ * -0.00508;
outjp1ic0 += _t_22_ * -0.0723189;
_t_28_ += in[j+10][i];
_t_43_ += in[j+10][i];
_t_28_ += in[j+10][i+8];
_t_43_ += in[j+10][i+8];
outjp2ic0 = in[j+6][i+4] * 8.10655;
outjp2ic0 += _t_28_ * 3.18622;
_t_43_ += in[j+11][i+1];
_t_43_ += in[j+11][i+7];
outjp3ic0 = in[j+7][i+4] * 8.10655;
outjp3ic0 += _t_43_ * 4.5339;
_t_45_ += in[j+11][i+3];
_t_45_ += in[j+11][i+5];
outjp3ic0 += _t_45_ * 0.002856;
_t_24_ = in[j+3][i+3];
_t_24_ += in[j+3][i+5];
_t_24_ += in[j+4][i+2];
_t_24_ += in[j+4][i+6];
_t_24_ += in[j+6][i+2];
_t_24_ += in[j+6][i+6];
_t_24_ += in[j+7][i+3];
_t_24_ += in[j+7][i+5];
outjp1ic0 += _t_24_ * -0.32;
_t_35_ = in[j+3][i+3];
_t_35_ += in[j+3][i+5];
_t_35_ += in[j+5][i+1];
_t_35_ += in[j+5][i+7];
_t_35_ += in[j+7][i+1];
_t_35_ += in[j+7][i+7];
_t_48_ = in[j+4][i+2];
_t_48_ += in[j+4][i+6];
_t_48_ += in[j+5][i+1];
_t_48_ += in[j+5][i+7];
_t_50_ = in[j+4][i+4];
_t_50_ += in[j+7][i+1];
_t_50_ += in[j+7][i+7];
_t_37_ = in[j+4][i+2];
_t_37_ += in[j+4][i+6];
_t_37_ += in[j+8][i+2];
_t_37_ += in[j+8][i+6];
outjp2ic0 += _t_37_ * 0.04;
_t_52_ = in[j+5][i+3];
_t_52_ += in[j+5][i+5];
_t_52_ += in[j+6][i+2];
_t_52_ += in[j+6][i+6];
_t_52_ += in[j+8][i+2];
_t_52_ += in[j+8][i+6];
_t_39_ = in[j+4][i+4];
_t_39_ += in[j+6][i+2];
_t_39_ += in[j+6][i+6];
_t_39_ += in[j+8][i+4];
outjp2ic0 += _t_39_ * 0.56944;
_t_27_ = in[j+4][i+4];
_t_27_ += in[j+5][i+3];
_t_27_ += in[j+5][i+5];
_t_27_ += in[j+6][i+4];
outjp1ic0 += _t_27_ * -4.55552;
_t_40_ = in[j+5][i+3];
_t_40_ += in[j+5][i+5];
_t_40_ += in[j+7][i+3];
_t_40_ += in[j+7][i+5];
outjp2ic0 += _t_40_ * 2.56;
_t_55_ = in[j+6][i+4];
_t_55_ += in[j+7][i+3];
_t_55_ += in[j+7][i+5];
_t_55_ += in[j+8][i+4];
outjp3ic0 += _t_55_ * -4.55552;
_t_17_ += in[j+9][i+3];
_t_35_ += in[j+9][i+3];
_t_52_ += in[j+9][i+3];
_t_17_ += in[j+9][i+5];
outjp1ic0 += _t_17_ * 0.002856;
_t_35_ += in[j+9][i+5];
outjp2ic0 += _t_35_ * 0.04064;
_t_52_ += in[j+9][i+5];
outjp3ic0 += _t_52_ * -0.32;
_t_15_ += in[j+9][i+1];
_t_33_ += in[j+9][i+1];
_t_48_ += in[j+9][i+1];
_t_15_ += in[j+9][i+7];
outjp1ic0 += _t_15_ * 4.5339;
_t_33_ += in[j+9][i+7];
outjp2ic0 += _t_33_ * 0.00064516;
_t_48_ += in[j+9][i+7];
_t_30_ += in[j+10][i+2];
_t_48_ += in[j+10][i+2];
_t_30_ += in[j+10][i+6];
outjp2ic0 += _t_30_ * -0.000357;
_t_48_ += in[j+10][i+6];
outjp3ic0 += _t_48_ * -0.00508;
_t_32_ += in[j+10][i+4];
outjp2ic0 += _t_32_ * -0.00508225;
_t_50_ += in[j+10][i+4];
outjp3ic0 += _t_50_ * -0.0723189;
_t_21_ = in[j+2][i+3];
_t_21_ += in[j+2][i+5];
_t_21_ += in[j+4][i+1];
_t_21_ += in[j+4][i+7];
_t_21_ += in[j+6][i+1];
_t_21_ += in[j+6][i+7];
_t_21_ += in[j+8][i+3];
_t_21_ += in[j+8][i+5];
outjp1ic0 += _t_21_ * 0.04064;
_t_31_ = in[j+2][i+3];
_t_31_ += in[j+2][i+5];
_t_31_ += in[j+5][i];
_t_31_ += in[j+5][i+8];
_t_31_ += in[j+7][i];
_t_31_ += in[j+7][i+8];
_t_44_ = in[j+3][i+2];
_t_44_ += in[j+3][i+6];
_t_44_ += in[j+5][i];
_t_44_ += in[j+5][i+8];
_t_46_ = in[j+3][i+4];
_t_46_ += in[j+7][i+8];
_t_46_ += in[j+7][i];
_t_44_ += in[j+11][i+2];
_t_44_ += in[j+11][i+6];
_t_46_ += in[j+11][i+4];
outjp3ic0 += _t_46_ * -0.00508225;
_t_23_ = in[j+3][i+2];
_t_23_ += in[j+3][i+6];
_t_23_ += in[j+7][i+2];
_t_23_ += in[j+7][i+6];
outjp1ic0 += _t_23_ * 0.04;
_t_34_ = in[j+3][i+2];
_t_34_ += in[j+3][i+6];
_t_34_ += in[j+4][i+1];
_t_34_ += in[j+4][i+7];
_t_34_ += in[j+8][i+1];
_t_34_ += in[j+8][i+7];
_t_47_ = in[j+4][i+1];
_t_47_ += in[j+4][i+7];
_t_19_ = in[j+2][i+1];
_t_19_ += in[j+2][i+7];
_t_19_ += in[j+8][i+1];
_t_19_ += in[j+8][i+7];
outjp1ic0 += _t_19_ * 0.00064516;
_t_29_ = in[j+2][i+1];
_t_29_ += in[j+2][i+7];
_t_29_ += in[j+3][i];
_t_29_ += in[j+3][i+8];
_t_49_ = in[j+4][i+3];
_t_49_ += in[j+4][i+5];
_t_49_ += in[j+6][i+1];
_t_49_ += in[j+6][i+7];
_t_49_ += in[j+8][i+1];
_t_49_ += in[j+8][i+7];
_t_42_ = in[j+3][i];
_t_42_ += in[j+3][i+8];
_t_36_ = in[j+3][i+4];
_t_36_ += in[j+6][i+1];
_t_36_ += in[j+6][i+7];
_t_25_ = in[j+3][i+4];
_t_25_ += in[j+5][i+2];
_t_25_ += in[j+5][i+6];
_t_25_ += in[j+7][i+4];
outjp1ic0 += _t_25_ * 0.56944;
_t_14_ += in[j+9][i];
_t_29_ += in[j+9][i];
_t_44_ += in[j+9][i];
_t_14_ += in[j+9][i+8];
outjp1ic0 += _t_14_ * 3.18622;
_t_29_ += in[j+9][i+8];
_t_44_ += in[j+9][i+8];
outjp3ic0 += _t_44_ * -0.000357;
_t_31_ += in[j+10][i+3];
_t_49_ += in[j+10][i+3];
_t_31_ += in[j+10][i+5];
outjp2ic0 += _t_31_ * 0.002856;
_t_49_ += in[j+10][i+5];
outjp3ic0 += _t_49_ * 0.04064;
_t_29_ += in[j+10][i+1];
_t_47_ += in[j+10][i+1];
_t_29_ += in[j+10][i+7];
outjp2ic0 += _t_29_ * 4.5339;
_t_47_ += in[j+10][i+7];
outjp3ic0 += _t_47_ * 0.00064516;
_t_42_ += in[j+11][i];
_t_42_ += in[j+11][i+8];
outjp3ic0 += _t_42_ * 3.18622;
_t_41_ = in[j+5][i+4];
_t_41_ += in[j+6][i+3];
_t_41_ += in[j+6][i+5];
_t_41_ += in[j+7][i+4];
outjp2ic0 += _t_41_ * -4.55552;
_t_53_ = in[j+5][i+4];
_t_53_ += in[j+7][i+2];
_t_53_ += in[j+7][i+6];
_t_38_ = in[j+4][i+3];
_t_38_ += in[j+4][i+5];
_t_38_ += in[j+5][i+2];
_t_38_ += in[j+5][i+6];
_t_38_ += in[j+7][i+2];
_t_38_ += in[j+7][i+6];
_t_38_ += in[j+8][i+3];
_t_38_ += in[j+8][i+5];
outjp2ic0 += _t_38_ * -0.32;
_t_26_ = in[j+4][i+3];
_t_26_ += in[j+4][i+5];
_t_26_ += in[j+6][i+3];
_t_26_ += in[j+6][i+5];
outjp1ic0 += _t_26_ * 2.56;
_t_54_ = in[j+6][i+3];
_t_54_ += in[j+6][i+5];
_t_54_ += in[j+8][i+3];
_t_54_ += in[j+8][i+5];
outjp3ic0 += _t_54_ * 2.56;
_t_51_ = in[j+5][i+2];
_t_51_ += in[j+5][i+6];
_t_16_ += in[j+9][i+2];
_t_34_ += in[j+9][i+2];
_t_51_ += in[j+9][i+2];
_t_16_ += in[j+9][i+6];
outjp1ic0 += _t_16_ * -0.000357;
_t_34_ += in[j+9][i+6];
outjp2ic0 += _t_34_ * -0.00508;
_t_51_ += in[j+9][i+6];
outjp3ic0 += _t_51_ * 0.04;
_t_18_ += in[j+9][i+4];
outjp1ic0 += _t_18_ * -0.00508225;
out[j+1][i] = outjp1ic0;
_t_36_ += in[j+9][i+4];
outjp2ic0 += _t_36_ * -0.0723189;
out[j+2][i] = outjp2ic0;
_t_53_ += in[j+9][i+4];
outjp3ic0 += _t_53_ * 0.56944;
out[j+3][i] = outjp3ic0;
	} 
}

extern "C" void host_code (double *h_in, double *h_out, int N) {
	double *in;
	cudaMalloc (&in, sizeof(double)*N*N);
	check_error ("Failed to allocate device memory for in\n");
	cudaMemcpy (in, h_in, sizeof(double)*N*N, cudaMemcpyHostToDevice);
	double *out;
	cudaMalloc (&out, sizeof(double)*N*N);
	check_error ("Failed to allocate device memory for out\n");

	dim3 blockconfig (16, 8);
	dim3 gridconfig (ceil(N, blockconfig.x), ceil(N, 4*blockconfig.y));

	j2d81pt<<<gridconfig, blockconfig>>> (in, out, N);

	cudaMemcpy (h_out, out, sizeof(double)*N*N, cudaMemcpyDeviceToHost);
	cudaFree (in); 
	cudaFree (out);
}
